from typing import Any, Callable, Tuple

from flask_openipa.schemas.plugins.base import BaseSchemaPlugin


class OpenAPISchemaBuilder:
    """Helper class used to generate openapi schema from various python objects.
    
    :param plugins: List of flask_openipa.schemas.plugin.base.BaseSchemaPlugin
    """

    def __init__(self, plugins: Tuple[BaseSchemaPlugin, ...] = None):
        self.plugins = plugins if plugins is not None else ()
        self.schemas = {}
        self.on_new_schema(lambda name, schema: self.schemas.update({name: schema}))

    def add_schema(self, schema: Any):
        """Recursively add nested schemas to the list of openapi schemas.
        
        :return: A reference to the top level schema or list of schemas
        """
        for plugin in self.plugins:
            try:
                # openapi schema is generated by first plugin that can handle it
                return plugin.add_schema(schema)
            except NotImplementedError:
                continue

    def on_new_schema(self, new_schema_handler: Callable[[str, dict], None]):
        for plugin in self.plugins:
            plugin.on_new_schema(new_schema_handler)
